structure Int =
   struct
      type int = int
   end
structure LargeInt =
   struct
      type int = intInf
   end

signature INTEGER_GLOBAL =
   sig
      eqtype int
   end

signature PRE_INTEGER =
   sig
      include INTEGER_GLOBAL
      val precision: Int.int option 
      val minInt: int option 
      val maxInt: int option 
      val toInt: int -> Int.int 
      val fromInt: Int.int -> int 
      val ~ : int -> int 
      val * : int * int -> int 
      val quot: int * int -> int 
      val rem: int * int -> int
      val + : int * int -> int 
      val - : int * int -> int 
      val > : int * int -> bool 
      val >= : int * int -> bool 
      val < : int * int -> bool 
      val <= : int * int -> bool 
   end

signature INTEGER =
   sig
      include PRE_INTEGER
      val toLarge: int -> LargeInt.int 
      val fromLarge: LargeInt.int -> int 
      val div: int * int -> int 
      val mod: int * int -> int 
      val compare: int * int -> order 
      val abs: int -> int 
      val min: int * int -> int 
      val max: int * int -> int 
      val sign: int -> Int.int 
      val sameSign: int * int -> bool 
      val fmt: StringCvt.radix -> int -> string 
      val toString: int -> string 
      val fromString: string -> int option 
      val scan:
	 StringCvt.radix
	 -> (char, 'a) StringCvt.reader
	 -> (int, 'a) StringCvt.reader
   end

signature INTEGER_EXTRA =
   sig
      include INTEGER

      val geu: int * int -> int
      val gtu: int * int -> int
      val maxInt': int
      val minInt': int
      val power: {base: int, exp: int} -> int
   end
