(* Copyright (C) 1997-1999 NEC Research Institute.
 * Please see the file LICENSE for license information.
 *)
(* Patch in fromLarge and toLarge now that IntInf is defined.
 *)

structure Int32 =
   struct
      open Int32

      val fromLarge = IntInf.toInt
      val toLarge = IntInf.fromInt
   end
structure Int = Int32
(* 
 * structure Int31 =
 *    struct
 *       open Int31
 * 
 *       val fromLarge = fromInt o Int32.fromLarge
 *       val toLarge = Int32.toLarge o toInt
 *    end
 * 
 *)

structure Word8 =
   struct
      open Word8

      val toLargeIntX = IntInf.fromInt o toIntX
      val toLargeInt = IntInf.fromInt o toInt
   end

structure Word32 =
   struct
      open Word32

      val toLargeIntX = IntInf.fromInt o toIntX

      fun highBitSet w = Int.<(toIntX w, 0)

      fun toLargeInt(w: word): LargeInt.int =
	 if highBitSet w
	    then IntInf.+(0x80000000, toLargeIntX(andb(w, 0wx7FFFFFFF)))
	 else toLargeIntX w
   end
