(* Copyright (C) 1997-1999 NEC Research Institute.
 * Please see the file LICENSE for license information.
 *)
structure Word32: WORD_EXTRA =
   Word
   (structure P = Primitive.Word32
    open P
       
    type word = word

    val wordSize = 32
    val wordSizeWord = 0w32
    val zero: word = 0w0

    local
       fun id x = x
    in
       val toLargeWord = id
       val toLargeWordX = id
       val fromLargeWord = id
    end

    fun highBitSet w = Int.<(toIntX w, 0)
	  
    fun toInt w =
       if safe andalso highBitSet w
	  then raise Overflow
       else toIntX w

    val {compare, min, max} = Util.makeCompare(op <)
       )

structure Word = Word32
structure WordGlobal: WORD_GLOBAL = Word
open WordGlobal
structure LargeWord = Word32
structure SysWord = Word32
   
