functor CallCC(type stack
	       val saveStack: unit -> stack
	       val restoreStack: stack -> unit):
   sig
      type 'a cont
      val callcc: ('a cont -> 'a) -> 'a
      val throw: 'a cont -> 'a -> 'b
   end =
struct

type 'a cont = 'a -> unit
   
fun 'a callcc(f: 'a cont -> 'a): 'a =
   let
      val r: 'a option ref = ref NONE
      val s = saveStack()
   in case !r of
      NONE => f(fn v => (r := SOME v; restoreStack s))
    | SOME v => (r := NONE (* for space safety *)
		 ; v)
   end

exception ThrowBug
fun ('a, 'b) throw(k: 'a cont) (v: 'a): 'b = (k v; raise ThrowBug)
   
end
