(* Copyright (C) 1997-1999 NEC Research Institute.
 * Please see the file LICENSE for license information.
 *)
structure MLton: MLTON =
   struct
      val size = _prim "MLTON_MLton_size": 'a -> int;

      structure GC =
	 struct
	    val messages = _prim "MLTON_MLton_gcMessages": bool -> unit;
	    val summary = _prim "MLTON_MLton_gcSummary": bool -> unit;

	    fun collect() =
	       (* size causes a collection do happen. *)
	       (size "z"; ())
	 end
      
      val cleanAtExit = AtExit.clean
	 
      val random = Primitive.MLton.random
	 
      val safe = safe

      datatype status = Original | Clone
	 
      local
	 val saveWorld = _prim "MLTON_MLton_saveWorld": string -> bool;
      in
	 (* Need to worry about:
	  *   - print out list of open file descriptors
	  *   - redetermine buffer status when restart
	  *)
	 val saveWorld =
	    fn file => (AtSaveWorld.clean();
			if saveWorld(String.nullTerm file)
			   then Original
			else Clone)
      end

      local
	 structure S =
	    CallCC(type stack = stack
		   val saveStack = _prim "MLTON_MLton_saveStack": unit -> stack;
		   val restoreStack =
		      _prim "MLTON_MLton_restoreStack": stack -> unit;)
      in
	 open S
      end
   end
