(* Copyright (C) 1997-1999 NEC Research Institute.
 * Please see the file LICENSE for license information.
 *)
structure SMLofNJ: SML_OF_NJ =
   struct
      structure Cont = MLton
	 
      structure SysInfo =
	 struct
	    fun getHostArch() = "X86"
	    fun getOSName() = "Linux"
	 end
      
      structure Internals =
	 struct
	    structure GC =
	       struct
		  fun messages _ = ()
	       end
	 end

      val getCmdName = CommandLine.name
      val getArgs = CommandLine.arguments

      fun getAllArgs() = getCmdName() :: getArgs()
	 
      fun exportFn(file, f) =
	 OS.Process.exit
	 (case MLton.saveWorld(file ^ ".mlton") of
	     MLton.Original => 0
	   | MLton.Clone => f(getCmdName(), getArgs()))

      fun exportML f =
	 case MLton.saveWorld f of
	    MLton.Original => false
	  | MLton.Clone => true
   end
   
