(* Copyright (C) 1997-1999 NEC Research Institute.
 * Please see the file LICENSE for license information.
 *)
(* This apparently useless rebinding is so that primitives don't appear in
 * the overload declarations when using the monomorphiser.
 *)

local
   nonfix + - * div mod / < <= > >=
   structure Char =
      struct
	 open Char
	 val < = <
	 val <= = <=
	 val > = >
	 val >= = >=
      end

   structure Int =
      struct
	 open Int
	 val ~ = ~
	 val + = +
	 val - = -
	 val * = *
	 val div = div
	 val mod = mod
	 val < = <
	 val <= = <=
	 val > = >
	 val >= = >=
	 val abs = abs
      end

   structure IntInf =
      struct
	 open IntInf
	 val ~ = ~
	 val + = +
	 val - = -
	 val * = *
(*	 val div = div *)
(*	 val mod = mod *)
	 val < = <
	 val <= = <=
	 val > = >
	 val >= = >=
	 val abs = abs
      end

   structure Real =
      struct
	 open Real
	 val ~ = ~
	 val + = +
	 val - = -
	 val * = *
	 val / = /
	 val < = <
	 val <= = <=
	 val > = >
	 val >= = >=
	 val abs = abs
      end

   structure String =
      struct
	 open String
	 val < = <
	 val <= = <=
	 val > = >
	 val >= = >=
      end

   structure Word8 =
      struct
	 open Word8
	 val + = +
	 val - = -
	 val * = *
	 val div = div
	 val mod = mod
	 val < = <
	 val <= = <=
	 val > = >
	 val >= = >=
      end

   structure Word =
      struct
	 open Word
	 val + = +
	 val - = -
	 val * = *
	 val div = div
	 val mod = mod
	 val < = <
	 val <= = <=
	 val > = >
	 val >= = >=
      end
in

   _overload ~ :   ('a -> 'a)
   as  Int.~
   and IntInf.~
   and Real.~

   _overload + :   ('a * 'a -> 'a)
   as  Int.+
   and IntInf.+
   and Word.+
   and Word8.+
   and Real.+

   _overload - :   ('a * 'a -> 'a)
   as  Int.-
   and IntInf.-
   and Word.-
   and Word8.-
   and Real.-

   _overload * :   ('a * 'a -> 'a)
   as  Int.*
   and IntInf.*
   and Word.*
   and Word8.*
   and Real.*

   _overload / : ('a * 'a -> 'a)
   as Real./

   _overload div: ('a * 'a -> 'a)
   as  Int.div
   and Word.div
   and Word8.div

   _overload mod: ('a * 'a -> 'a)
   as  Int.mod
   and Word.mod
   and Word8.mod

   _overload < :   ('a * 'a -> bool)
   as  Int.<
   and IntInf.<
   and Word.<
   and Word8.<
   and Real.<
   and Char.<
   and String.<

   _overload <= :   ('a * 'a -> bool)
   as  Int.<=
   and IntInf.<=
   and Word.<=
   and Word8.<=
   and Real.<=
   and Char.<=
   and String.<=

   _overload > :   ('a * 'a -> bool)
   as  Int.>
   and IntInf.>
   and Word.>
   and Word8.>
   and Real.>
   and Char.>
   and String.>

   _overload >= :   ('a * 'a -> bool)
   as  Int.>=
   and IntInf.>=
   and Word.>=
   and Word8.>=
   and Real.>=
   and Char.>=
   and String.>=

   _overload abs: ('a -> 'a)
   as  Int.abs
   and IntInf.abs
   and Real.abs
end
