(* Copyright (C) 1997-1999 NEC Research Institute.
 * Please see the file LICENSE for license information.
 *)
functor AstConst(S: AST_CONST_STRUCTS) :> AST_CONST =
struct
	 
datatype t =
   Int of string
 | Word of Word32.word
 | Real of string
 | String of string
 | Char of char

val equals = fn _ => Error.unimplemented "Ast.Const.equals"

val fromInt = Int o Int.toString

local
   open Layout
   fun wrap(pre, post, s) = str(pre ^ String.toString s ^ post)
in
   fun layout c =
      case c of
	 Int s => str s
       | Real l => String.layout l
       | Word w => seq[str "0wx", str(Word32.toString w)]
       | Char c => wrap("#\"", "\"", String.implode[c])
       | String s => wrap("\"", "\"", s)
end

end
