(* Copyright (C) 1997-1999 NEC Research Institute.
 * Please see the file LICENSE for license information.
 *)
signature TYVAR_STRUCTS = 
   sig
   end

signature TYVAR = 
   sig
      include TYVAR_STRUCTS
      include T
      include WRAPPED sharing type obj = t

      (* create a new type variable *)
      val new: {name: string, equality: bool} -> t

      (* create a new type variable named a_n, where n is a counter *)
      val newNoname: {equality: bool} -> t

      (* reset the counter for new type variables *)
      val reset: unit -> unit 

      (* newString "'a" creates a type variable named a
       * newString "''a" creates an equality type variable named a
       *)
      val newString: string * int * int -> t

      (* predicates *)
      val isEquality: t -> bool
      val sameName: t * t -> bool

      val hash: t -> word

      val plist: t -> PropertyList.t
      val clear: t -> unit

      (* layout a list of type variables *)
      val layouts: t list -> Layout.t
   end

