(* Copyright (C) 1997-1999 NEC Research Institute.
 * Please see the file LICENSE for license information.
 *)
signature CONST_STRUCTS = 
   sig
      structure Ast: AST
      structure Tycon: TYCON
      sharing Tycon.AstId = Ast.Tycon
      structure SmallIntInf: SMALL_INT_INF
   end

signature CONST = 
   sig
      include CONST_STRUCTS

      type t

      datatype node =
	 Char of char
       | Int of Int32.int
       | SmallIntInf of SmallIntInf.t
       | IntInf of string
       | Real of string
       | String of string
       | Word of Word32.word

      val make: node * Tycon.t -> t
	 
      val node: t -> node
      val tycon: t -> Tycon.t

      val fromInt: int -> t
      val fromString: string -> t

      val toAstExp: t -> Ast.Exp.t
      val toAstPat: t -> Ast.Pat.t

      val hash: t -> word
	 
      val equals: t * t -> bool
      val layout: t -> Layout.t
   end
