(* Copyright (C) 1997-1999 NEC Research Institute.
 * Please see the file LICENSE for license information.
 *)
functor ExtractTargs(S: EXTRACT_TARGS_STRUCTS): EXTRACT_TARGS = 
struct

open S

fun extract{prim, args, result} =
   let open Prim.Name
   in case (Prim.name prim, args) of
      (Array, _) => [Type.dearray result]
    | (ArraySub, _) => [result]
    | (VectorSub, _) => [result]
    | (ArrayUpdate, [_, _, z]) => [z]
    | (ArrayLength, [z]) => [Type.dearray z]
    | (VectorLength, [z]) => [Type.devector z]
    | (VectorFromArray, [z]) => [Type.dearray z]
    | (Ref, [z]) => [z]
    | (Deref, _) => [result]
    | (Assign, [_, z]) => [z]
    | (Equal, [z, _]) => [z]
    | (Eq, [z, _]) => [z]
    | (Size, [z]) => [z]
    | _ => []
   end
   
end
