(* Copyright (C) 1997-1999 NEC Research Institute.
 * Please see the file LICENSE for license information.
 *)
signature ID_STRUCTS =
   sig
      structure AstId: AST_ID
      val noname: string
   end

signature ID =
   sig
      include ID_STRUCTS
      include T

      (* raw constructor - doesn't add uniquefying suffix *)
      val fromString: string -> t

      (* raw destructor *)
      val originalName: t -> string
	 
      (* constructors *)
      val bogus: t
      val new: t -> t            (* with the same prefix *)
      val newString: string -> t (* given prefix *)
      val newNoname: unit -> t   (* prefix is "noName" *)

      (* conversions *)
      val fromAst: AstId.t -> t
      val fromAsts: AstId.t list -> t list
      val toAst: t -> AstId.t
      val toAsts: t list -> AstId.t list

      val toString: t -> string

      val sameName: t * t -> bool

      val setName: t * string -> unit

      val plist: t -> PropertyList.t
      val clear: t -> unit
   end

signature HASH_ID =
   sig
      include ID

      val hash: t -> word 
   end
