(* Copyright (C) 1997-1999 NEC Research Institute.
 * Please see the file LICENSE for license information.
 *)
signature SMALL_INT_INF_STRUCTS = 
   sig
   end

signature SMALL_INT_INF = 
   sig
      include SMALL_INT_INF_STRUCTS
      
      type t

      (* The argument is a SML language integer literal.
       * Given a string which consists of
       *	an optional ~
       *	either one or more of [0-9]
       *            or 0x followed by one or more of [0-9a-fA-F]
       * if it fits in a fixnum IntInf.int, return SOME of the corresponding
       * word.  If it doesn't, return NONE.
       *)
      val fromString: string -> t option
	 
      val toMLstring: t -> string
      val toCstring: t -> string

      val hash: t -> word

      val equals: t * t -> bool
   end
