(* Copyright (C) 1997-1999 NEC Research Institute.
 * Please see the file LICENSE for license information.
 *)
signature BACKEND_STRUCTS = 
   sig
      structure Cps: CPS
      structure Machine: MACHINE

      val funcToLabel: Cps.Func.t -> Machine.Label.t
      val jumpToLabel: Cps.Jump.t -> Machine.Label.t

      sharing Cps.Jump = Machine.Label
      sharing Cps.Const.SmallIntInf = Machine.SmallIntInf
      sharing Cps.Prim = Machine.Prim
   end

signature BACKEND = 
   sig
      include BACKEND_STRUCTS
      
      val generate: Cps.Program.t -> Machine.Program.t
   end
