(* Copyright (C) 1997-1999 NEC Research Institute.
 * Please see the file LICENSE for license information.
 *)
functor LimitCheck(S: LIMIT_CHECK_STRUCTS): LIMIT_CHECK = 
struct

open S
open Dec Transfer
   
fun limitCheck(Program.T{functions, ...}) =
   let
      val {get = limitCheck, set = setLimitCheck} =
	 Property.new(Jump.plist, Property.initConst false)

      val {get = inBody, set = setInBody, destroy} =
	 Property.newDest(Jump.plist, Property.initConst false)

      fun loopExp e =
	 let val {decs, transfer} = Exp.dest e
	 in List.foreach(Exp.decs e,
			 fn Fun{name, body, ...} => (setInBody(name, true)
						     ; loopExp body
						     ; setInBody(name, false))
			  | HandlerPush h => setLimitCheck(h, true)
			  | _ => ())
	    ; (case transfer of
		  Jump{dst, ...} => (if inBody dst
					then setLimitCheck(dst, true)
				     else ())
		| Call{cont, ...} => (case cont of
					 SOME c => setLimitCheck(c, true)
				       | _ => ())
		| _ => ())
	 end
   in
      List.foreach(functions, loopExp o #body)
      ; destroy()
      ; limitCheck
   end
   
end


