(* Copyright (C) 1997-1999 NEC Research Institute.
 * Please see the file LICENSE for license information.
 *)
signature LIVE_STRUCTS = 
   sig
      structure Cps: CPS
   end

signature LIVE = 
   sig
      include LIVE_STRUCTS
      
      type t

      val live:
	 {
	  exp: Cps.Exp.t,
	  shouldConsider: Cps.Var.t -> bool,
	  jumpHandlers: Cps.Jump.t -> Cps.Jump.t list
	 }
	 -> {
	     (* live variables at beginning of block *)
	     liveBegin: Cps.Jump.t -> Cps.Var.t list,

	     (* live variables at the beginning of a block, excepting its formals
	      *)
	     liveBeginNoFormals: Cps.Jump.t -> Cps.Var.t list,
	     
	     (* live variables at array allocation *)
	     liveArray: Cps.Var.t -> Cps.Var.t list,

	     destroy: unit -> unit
	     }
   end
