(* Copyright (C) 1997-1999 NEC Research Institute.
 * Please see the file LICENSE for license information.
 *)
signature MTYPE_STRUCTS = 
   sig
   end

signature MTYPE = 
   sig
      include MTYPE_STRUCTS

      type t
	 
      datatype dest =
	 Char
       | Double
       | Int
       | Pointer
       | Uint
       | Void

      val all: t list

      val dest: t -> dest

      val char: t
      val double: t
      val int: t
      val pointer: t
      val uint: t
      val void: t

      val label: t (* same as uint *)
	 
      val isVoid: t -> bool
      val isPointer: t -> bool

      (* align an address *)	 
      val align: int * t -> int

      val toString: t -> string
	 
      val size: t -> int (* bytes *)
      val equals: t * t -> bool
      val layout: t -> Layout.t

      val memo: (t -> 'a) -> (t -> 'a)
   end
