(* Copyright (C) 1997-1999 NEC Research Institute.
 * Please see the file LICENSE for license information.
 *)
functor ParallelMove(S: PARALLEL_MOVE_STRUCTS): PARALLEL_MOVE = 
struct

open S

fun ('reg, 'statement) move{moves, equals, move, temp} : 'statement list =
   let
      val mvs =
	 List.fold(moves, [], fn (mv as {src, dst}, mvs) =>
		   if equals(src, dst)
		      then mvs
		   else mv :: mvs)
      fun loopTop(mvs, moves) = loop(mvs, [], moves, false)
      and loop(mvs, hard, moves, changed) =
	 case mvs of
	    [] =>
	       (case hard of
		   [] => List.reverse moves
		 | {src, dst} :: hard' => 
		      if changed
			 then loopTop(hard, moves)
		      else
			 let
			    val temp = temp src
			    val moves =
			       move{src = src, dst = dst}
			       :: move{dst = temp, src = dst}
			       :: moves
			    val hard =
			       List.map(hard', fn mv as {src = s, dst = d} =>
					if equals(dst, s)
					   then {src = temp, dst = d}
					else mv)
			 in loopTop(hard, moves)
			 end)
	  | (mv as {src, dst}) :: mvs =>
	       let fun isHard l = List.exists(l, fn {src, dst = _} =>
					      equals(dst, src))
	       in if isHard mvs orelse isHard hard
		     then loop(mvs, mv :: hard, moves, changed)
		  else loop(mvs, hard,
			    move{src = src, dst = dst} :: moves,
			    true)
	       end
   in loopTop(mvs, [])
   end

end
