(* Copyright (C) 1997-1999 NEC Research Institute.
 * Please see the file LICENSE for license information.
 *)
signature PARALLEL_MOVE_STRUCTS = 
   sig
   end

signature PARALLEL_MOVE = 
   sig
      include PARALLEL_MOVE_STRUCTS

      (* Allows overlapping froms and tos.
       * Hence, has to be careful to use temps.
       * 'a is the type of "registers"
       * 'b is the type of "statements"
       *)
      val move:
	 {
	  moves: {src: 'a, dst: 'a} list,
	  (* are two registers the same *)
	  equals: 'a * 'a -> bool,
	  (* create a move statement *)
	  move: {src: 'a, dst: 'a} -> 'b,
	  (* return a new temporary register like input reg *)
	  temp: 'a -> 'a
	 } -> 'b list
   end
