(* Copyright (C) 1997-1999 NEC Research Institute.
 * Please see the file LICENSE for license information.
 *)
signature MLTON =
   sig
      structure GC:
	 sig
	    val collect: unit -> unit
	    val messages: bool -> unit
	    val summary: bool -> unit
	 end
	 
      val cleanAtExit: unit -> unit

      val random: unit -> Word32.word

      val safe: bool

      datatype status = Original | Clone
	 
      val saveWorld: string -> status

      (* Computes the size in bytes of an arbitrary object by performing
       * a partial gc using that object as the root.
       *)
      val size: 'a -> int

      type 'a cont
      val callcc: ('a cont -> 'a) -> 'a
      val throw: 'a cont -> 'a -> 'b
   end
