(* Copyright (C) 1997-1999 NEC Research Institute.
 * Please see the file LICENSE for license information.
 *)
signature ANALYZE_STRUCTS = 
   sig
      include CPS_TREE
   end

signature ANALYZE = 
   sig
      include ANALYZE_STRUCTS
      
      val analyze:
	 {
	  program: Program.t,

	  useFromTypeOnBinds: bool,
	  
	  fromType: Type.t -> 'a,

	  copy: 'a -> 'a,

	  coerce: {
		   from: 'a,
		   to: 'a
		  } -> unit,
	  const: Const.t -> 'a,
	  tuple: 'a list -> 'a,
	  select: {
		   tuple: 'a,
		   offset: int,
		   resultType: Type.t
		  } -> 'a,

	  (* NONE means merge all uses of same constructor *)
	  constructors:
	  {
	   conApp: {
		    con: Con.t,
		    args: 'a list
		   } -> 'a,
	   conSelect: {
		       variant: 'a,
		       con: Con.t,
		       offset: int
		      } -> 'a
	  } option,
	  
	  primApp: {
		    prim: Prim.t,
		    targs: Type.t list,
		    args: 'a list,
		    resultVar: Var.t,
		    resultType: Type.t
		   } -> 'a,

	  (* The value is part of a datatype -- intersect it so it must be
	   * of the specified variant
	   *)
	  filter: 'a * Con.t -> 'a
	 }
	 -> {
	     value: Var.t -> 'a,
	     conArgs: Con.t -> 'a list,
	     func: Func.t -> {args: 'a list,
			      returns: 'a list},
	     jump: Jump.t -> 'a list,
	     exnVals: 'a list option
	    }
   end
