(* Copyright (C) 1997-1999 NEC Research Institute.
 * Please see the file LICENSE for license information.
 *)
signature CPS_CALL_GRAPH_STRUCTS =
   sig
      structure CpsTree : CPS_TREE
      sharing CpsTree.Func = CpsTree.Jump
   end
      
signature CPS_CALL_GRAPH =
   sig
      include CPS_CALL_GRAPH_STRUCTS
      structure Graph : DIRECTED_GRAPH
     
      datatype t = T of {getNode: CpsTree.Func.t -> Graph.Node.t,
			 setNode: CpsTree.Func.t * Graph.Node.t -> unit,
			 isLeaf: Graph.Node.t -> bool,
			 getExpFromNode : Graph.Node.t -> { name : CpsTree.Func.t,
							   args : (CpsTree.Var.t * CpsTree.Type.t) list,
							   body : CpsTree.Exp.t },
			 getCallSites: Graph.Node.t -> CpsTree.Transfer.t list,
			 getSize: Graph.Node.t -> int,
			 setSize: Graph.Node.t * int -> unit}
	 
      val buildGraph : CpsTree.Program.t -> t
   end

signature CPS_SIZE_STRUCTS =
   sig
      structure CpsTree : CPS_TREE
      structure CallGraph : CPS_CALL_GRAPH
      sharing CpsTree = CallGraph.CpsTree
      sharing CpsTree.Func = CpsTree.Jump	
   end
	 
signature CPS_SIZE =
   sig
      structure CpsTree : CPS_TREE
      structure CallGraph : CPS_CALL_GRAPH
      val computeSize : CpsTree.Program.t * CallGraph.t -> unit
   end	       

signature CPS_INLINE_STRUCTS =
    sig
       include SHRINK
       sharing Func = Jump
      end

signature CPS_INLINE = 
    sig
        include CPS_TREE
  	val computeInline : Program.t -> Program.t
    end

