(* Copyright (C) 1997-1999 NEC Research Institute.
 * Please see the file LICENSE for license information.
 *)
functor RaiseToJump(S: RAISE_TO_JUMP_STRUCTS): RAISE_TO_JUMP = 
struct

open S
open Dec Transfer

fun raiseToJump(p as Program.T{datatypes, globals, functions, main}) =
   let
      val jumpHandlers = inferHandlers p
      fun loopExp(e: Exp.t, hs: Jump.t list): Exp.t =
	 let val {decs, transfer} = Exp.dest e
	 in Exp.make{decs = List.map(decs, loopDec),
		     transfer = (case transfer of
				    Raise args =>
				       (case List.fold(decs, hs, deltaHandlers) of
					   [] => transfer
					 | h :: _ =>
					      Jump{dst = h, args = args})
				  | _ => transfer)}
	 end
      and loopDec d =
	 case d of
	    Fun{name, args, body} =>
	       Fun{name = name, args = args,
		   body = loopExp(body, jumpHandlers name)}
	  | _ => d
   in Program.T{datatypes = datatypes,
		globals = globals,
		functions = List.map(functions, fn {name, args, body, returns} =>
				     {name = name,
				      args = args,
				      body = loopExp(body, []),
				      returns = returns}),
		main = main}
   end
   
end
