(* Copyright (C) 1997-1999 NEC Research Institute.
 * Please see the file LICENSE for license information.
 *)
functor RemoveUnusedFunctions(S: REMOVE_UNUSED_FUNCTIONS_STRUCTS)
   : REMOVE_UNUSED_FUNCTIONS = 
struct

open S

fun remove(Program.T{datatypes, globals, functions, main}) =
   let
      val {get: Func.t -> {body: Exp.t,
			   visited: bool ref},
	   set, destroy} =
	 Property.newDest(Func.plist,
			  Property.initRaise("info", Func.layout))
      val _ = List.foreach(functions, fn {name, body, ...} =>
			   set(name, {body = body, visited = ref false}))
      fun visit(f: Func.t) =
	 let val {visited, body} = get f
	 in if !visited
	       then ()
	    else (visited := true
		  ; Exp.foreachTransfer(body,
					fn Transfer.Call{func, ...} => visit func
					 | _ => ()))
	 end
      val _ = visit main
      val functions = List.keepAll(functions, fn f => !(#visited(get(#name f))))
   in destroy()
      ; Program.T{datatypes = datatypes,
		  globals = globals,
		  functions = functions,
		  main = main}
   end
	 

end
