(* Copyright (C) 1997-1999 NEC Research Institute.
 * Please see the file LICENSE for license information.
 *)
signature TWO_POINT_LATTICE_STRUCTS = 
   sig
      structure Top: sig
			type t
			val new: unit -> t
		     end
      structure Dest:
	 sig
	    type t
	    val bottom: t
	    val top: Top.t -> t
	 end
      (* pretty print names *)
      val bottom: string
      val top:string
   end

signature TWO_POINT_LATTICE = 
   sig
      include TWO_POINT_LATTICE_STRUCTS
      
      type t

      val dest: t -> Dest.t

      val new: unit -> t

      val isTop: t -> bool
      val isBottom: t -> bool

      (* handler will be run once iff value becomes top *)
      val addHandler: t * (unit -> unit) -> unit

      val makeTop: t -> unit

      (* force rhs to be top if lhs is *)
      val <= : t * t -> unit

      (* force lhs and rhs to be the same *)
      val == : t * t -> unit

      val layout: t -> Layout.t
   end
