(* Copyright (C) 1997-1999 NEC Research Institute.
 * Please see the file LICENSE for license information.
 *)
signature DECS_STRUCTS =
   sig
      structure Ast: AST
      structure CoreML: CORE_ML
      sharing Ast = CoreML.Ast
   end

signature DECS =
   sig
      include DECS_STRUCTS
      
      type dec = CoreML.Dec.t
	 
      type t

      (* empty list *)
      val empty: t

      (* primitive datatype and exception declarations *)
(*      val prim: t*)

      (* list with one dec *)
      val single: dec -> t

      (* add a dec to the end of the list *)
      val add: t * dec -> t

      (* append two lists *)
      val append: t * t -> t

      (* append a lot of lists *)
      val appends: t list -> t

      (* conversions from/to normal lists *)
      val fromList: dec list -> t
      val toList: t -> dec list

      val toAst: t -> Ast.Dec.t
      val layout: t -> Layout.t
   end

