(* Copyright (C) 1997-1999 NEC Research Institute.
 * Please see the file LICENSE for license information.
 *)
signature ELABORATE_PAT_STRUCTS = 
   sig
      structure Ast: AST
      structure CoreML: CORE_ML
      structure Decs: DECS
      structure ElaborateAtoms: ELABORATE_ATOMS
      structure Env: ELABORATE_ENV
      sharing Ast = CoreML.Ast
      sharing CoreML = Decs.CoreML = Env.CoreML
      sharing Decs = ElaborateAtoms.Decs
      sharing Env = ElaborateAtoms.Env
      sharing Env.TypeStr = ElaborateAtoms.TypeStr
   end

signature ELABORATE_PAT = 
   sig
      include ELABORATE_PAT_STRUCTS
      
      val elaboratePat :
	 {pat: Ast.Pat.t, env: Env.t, accum: Env.t} -> CoreML.Pat.t * Env.t

      val elaboratePats :
	 {pats: Ast.Pat.t list, env: Env.t, accum: Env.t}
	 -> CoreML.Pat.t list * Env.t
   end
