(* Copyright (C) 1997-1999 NEC Research Institute.
 * Please see the file LICENSE for license information.
 *)
signature ELABORATE_STRUCTS = 
   sig
      structure Ast: AST
      structure CoreML: CORE_ML
      sharing Ast = CoreML.Ast
   end

signature ELABORATE = 
   sig
      include ELABORATE_STRUCTS

      structure Basis: BASIS
      structure Decs: DECS
      sharing Decs = Basis.Decs
      sharing Ast = Basis.Ast
      sharing CoreML = Decs.CoreML

      (* if true, then opaque signature matching is used *)
      val useOpaque: bool ref

      structure Accum :
	 sig
	    datatype t = T of {decs: Decs.t,
			       basis: Basis.t}

	    val empty: t
	    val prim: unit -> t
	    val decs: t -> Decs.t
	    val basis: t -> Basis.t
	    val layoutDecs: t -> Layout.t
	 end
	 
      val elaborateProgram :
	 Ast.Program.t * Basis.t * Accum.t -> Basis.t * Accum.t
   end
