(* Copyright (C) 1997-1999 NEC Research Institute.
 * Please see the file LICENSE for license information.
 *)
signature PRECEDENCE_PARSE_STRUCTS =
   sig
      structure Ast: AST
      structure Env: ELABORATE_ENV
      sharing Ast = Env.Ast
   end

signature PRECEDENCE_PARSE =
   sig
      include PRECEDENCE_PARSE_STRUCTS

      val parsePat: Ast.Pat.t list * Env.t -> Ast.Pat.t

      val parseExp: Ast.Exp.t list * Env.t -> Ast.Exp.t

      val parseClause: Ast.Pat.t list * Env.t -> {func: Ast.Var.t,
						   args: Ast.Pat.t list}
   end
