structure Array3D =
   struct
      datatype 'a t =
	 T of {x1: int,
	       x2: int,
	       x3: int,
	       elts: 'a Array.t}

      exception New = Array.New
      fun new(x1, x2, x3, z) = 
	 if x1 <= 0 orelse x2 <= 0 orelse x3 <= 0 then raise New
	 else T{x1 = x1, x2 = x2, x3 = x3,
		elts = Array.new(x1 * x2 * x3, z)}

      exception Spot
      fun spot(T{x1, x2, x3, ...}, a1, a2, a3) =
	 if 0 <= a1 andalso a1 < x1
	    andalso 0 <= a2 andalso a2 <= x2
	    andalso 0 <= a3 andalso a3 <= x3
	    then x3 * (x2 * a1 + a2) + a3
	 else raise Spot

      fun elts(T{elts, ...}) = elts
	 
      fun sub(a, x1, x2, x3) = Array.sub(elts a, spot(a, x1, x2, x3))

      fun update(a, x1, x2, x3, z) = Array.update(elts a, spot(a, x1, x2, x3), z)
   end
