(*-------------------------------------------------------------------*)
(*                           ConvertArray                            *)
(*-------------------------------------------------------------------*)

functor ConvertArray(structure A: ARRAY
		     structure IS: INDEX_SHAPE
		     sharing A.IS.I = IS.I): ARRAY = 
struct

structure IS = IS
   


exception New = A.New

fun new(s, x) = T(s, A.new(IS.size convert s, x))

fun tabulate(s, f) = T(s, A.tabulate(Shape.convert s, fn i =>
				    f(to(i, s))))

fun sub(T(s, a), i) = A.sub(a, from(i, s))

fun update(T(s, a), i, x) = A.update(a, from(i, s), x)

fun swap(T(s, a), i, j) = A.swap(a, from(i, s), from(j, s))

fun foreach(T(s, a), f) = A.foreach(a, fn (i, x) => f(to(i, s), x))

(*
fun foreachDown(T(s, a), f) = A.foreachDown(a, fn (i, x) => f(to(i, s), x))
   *)

fun shuffle(T(_, a)) = A.shuffle a

fun getAndSet(T(s, a)) = let val {get, set} = A.getAndSet a
			in {get = fn i => get(from(i, s)),
			    set = fn (i, x) => set(from(i, s), x)}
			end

fun output(T(s, a), outputElt, out) =
   A.output(a, fn(i, x, out) => outputElt(to(i, s), x, out), out)

end
