structure MultiDimensionalArray =
   struct
      datatype 'a t =
	 T of {dimensions: int list,
	       elts: 'a Array.t}

      exception New = Array.New
      fun new(xs, z) = 
	 if List.exists(xs, fn x => x <= 0)
	    then raise New
	 else IntList.foldl(dimensions, 1, op *)
	    
      exception Spot
      fun spot(T{dimensions, ...}, xs) =
	 List.foldl2
	 (dimensions, xs, 0, fn (dim, x, spot) =>
	  if 0 <= x andalso x < dim
	     then dim * spot + x
	  else raise Spot

      fun elts(T{elts, ...}) = elts
	 
      fun sub(a, xs) = Array.sub(elts a, spot(a, xs))

      fun update(a, xs, z) = Array.update(elts a, spot(a, xs), z)
   end
