signature PACKED_BITS =
   sig
      type t
      val size: int
      val get: t * int -> bool
   end

signature PACKED_ARRAY =
   sig
      structure Pack: PACKED_BITS
      structure Unpack: PACKED_BITS
      structure I: INTEGER
      structure L: LIST
      sharing I = L.I
	 
      type t

      exception New
      val new: I.t * (I.t -> Pack.t) -> t
      val size: t -> I.t
      val sub: t * I.t -> Unpack.t
      val update: t * I.t * Pack.t -> unit
      val listTo: Pack.t L.t -> t
   end


