(*-------------------------------------------------------------------*)
(*                          PairIndexShape                           *)
(*-------------------------------------------------------------------*)

functor PairIndexShape(structure X: INDEX_SHAPE
		       structure Y: INDEX_SHAPE
		       sharing X.I = Y.I): INDEX_SHAPE =
struct

structure I = X.I

structure Index = Pair(structure X = X.Index
		       structure Y = Y.Index)

structure Shape =
   struct
      structure P = Pair(structure X = X.Shape
			 structure Y = Y.Shape)
      structure S = StandardSequence
      fun size(x, y) = I.mul(X.Shape.size x,
			    Y.Shape.size y)
      fun all(x, y) =
	 S.iterate(X.Shape.S.iterate(x
      open P
   end

fun toInt((xi, yi), (xs, ys)) =
   I.add(I.mul(X.toInt(xi, xs),
	       Y.Shape.size ys),
	 Y.toInt(yi, ys))

fun intTo(n, (xs, ys)) =
   let val c = Y.Shape.size ys
   in (X.intTo(I.divide(n, c), xs),
       Y.intTo(I.modulo(n, c), ys))
   end
   
end
