signature CHAR0 =
   sig
      type t

      val equals: t * t -> bool 
      val output: t * TextIO.outstream -> unit

      val compare: t * t -> Relation.t
      val < : t * t -> bool
      val <= : t * t -> bool
      val > : t * t -> bool
      val >= : t * t -> bool
      val max: t * t -> t
      val min: t * t -> t

      val space: t
      val dash: t
      val newline: t
      val minChar: t
      val maxChar: t

      val isPrint: t -> bool
      val isLower: t -> bool
      val isAscii: t -> bool
      val isUpper: t -> bool
      val isSpace: t -> bool
      val isAlphaNum: t -> bool
      val isGraph: t -> bool
      val isHexDigit: t -> bool
      val isDigit: t -> bool
      val isAlpha: t -> bool

      val succ: t -> t
      val pred: t -> t
	 
      val toInt: t -> int
      val fromInt: int -> t
      val toPrintable: t -> string

      val ord: t -> int
      val chr: int -> t

      val digitToInt: t -> int option

      val toString: t -> string
      val fromString: string -> t option

      val toCString: t -> string
      val fromCString: string -> t option
   end where type t = char
