structure Char0: CHAR0 =
struct

open Pervasive.Char

type t = char

val space = #" "
val dash = #"-"
val newline = #"\n"

val maxChar = #"\255"
val minChar = #"\000"
   
val toInt = ord
val fromInt = chr

val equals = op =

val {max, min, compare, ...} = Relation.lessEqual{< = op <, equals = equals}

val toString = Pervasive.String.str

fun digitToInt(c: t): int option =
   if isDigit c
      then SOME(ord c - ord #"0")
   else NONE

fun toPrintable c =
   if isPrint c
      then (case c of
	       #"\"" => "\\\""
	     | #"\\" => "\\\\"
	     | _ => toString c)
   else (case c of
	    #"\n" => "\\n"
	  | #"\t" => "\\t"
	  | _ => "\\" ^ (let val n = ord c
			    val d1 = n div 100
			    val n = n - d1 * 100
			    val d2 = n div 10
			    val d3 = n - d2 * 10
			    val t = Pervasive.Int.toString
			 in t d1 ^ t d2 ^ t d3
			 end))

val toCString =
   fn #"\000" => "\\000"
    | c => toCString c
	 
fun output(c, out) = Pervasive.IO.output(out, toString c)

end
