signature INSTREAM =
   sig
      type t

      val standard: t
      val openIn: string -> t
      val close: t -> unit

      val endOf: t -> bool

      val sameContents: t * t -> bool

      val peekChar: t -> char option

      val input: t -> string
      val inputN: t * int -> string
      val inputChar: t -> char option
      val inputLine: t -> string

      val ignoreSpaces: t -> unit

      (* inputTo(ins, pred) inputs up to but not including the first char
       that satisfies pred *)
      val inputTo: t * (char -> bool) -> string

      val inputToSpace: t -> string
      val inputToChar: t * char -> string
	 
      val inputAll: t -> string
      val outputAll: t * Out.t -> unit

      val inputNothing: t -> unit

      val layout: t -> Layout.t
   end
