(*-------------------------------------------------------------------*)
(*                              Option                               *)
(*-------------------------------------------------------------------*)

structure Option: OPTION =
struct

type 'a t = 'a option

open Pervasive.Option

fun map'(opt, f) =
   case opt of
      NONE => ()
    | SOME x => f x

fun map(opt, f) =
   case opt of
      NONE => NONE
    | SOME x => SOME(f x)

fun equals eq =
   fn (NONE, NONE) => true
    | (SOME x, SOME y) => eq(x, y)
    | _ => false

local open Layout
in fun layout layoutX opt =
   case opt of
      NONE => str "None"
    | SOME x => seq[str "Some(", layoutX x, str ")"]
end

end
