(*-------------------------------------------------------------------*)
(*                             Outstream                             *)
(*-------------------------------------------------------------------*)

structure Outstream: OUTSTREAM =
struct

structure O = Pervasive.IO
open O
   
type t = outstream
   
val standard = stdOut
val error = stdErr

fun ignore _ = ()

val close = closeOut
(*val outputc = O.outputc*)
fun outputc stream string = output(stream, string)
val flush = flushOut

fun newline s = output(s, "\n")
   
fun print s = output(standard, s)
   
fun outputNothing _ = ()

fun fluidLet(s1, s2, thunk) =
   let val old = O.getOutstream s1
   in O.setOutstream(s1, O.getOutstream s2)
      ; DynamicWind.dynamicWind(thunk, fn () => O.setOutstream(s1, old))
   end

fun output2 (outX, outY) ((x, y), out) =
   (output(out, "(") ;
    outX(x, out) ;
    output(out, ", ") ;
    outY(y, out) ;
    output(out, ")"))

fun output3 (outX, outY, outZ) ((x, y, z), out) =
   (output(out, "(") ;
    outX(x, out) ;
    output(out, ", ") ;
    outY(y, out) ;
    output(out, ", ") ;
    outZ(z, out) ;
    output(out, ")"))

fun tripleOutput(f, g, h) ((a, b, c), out) =
   let val print = outputc out
   in print "(" ;
      f(a, out) ;
      print ", " ;
      g(b, out) ;
      print ", " ;
      h(c, out) ;
      print ")"
   end

end

structure Out = Outstream
