structure String0: STRING0 =
struct

structure PC = Pervasive.Char
structure PS = Pervasive.String   
open PS
structure Char = Char0

type t = string

val empty = ""

val newline = "\n"

fun isEmpty "" = true
  | isEmpty _ = false
    
val length = size

fun last s = sub(s, length s - 1)

fun append(x, y) = x ^ y

exception ToChar
fun toChar s = if length s = 1 then sub(s, 0) else raise ToChar

val fromChar = str

fun contains(s, c) = PC.contains s c

val equals = op =
   
val {compare, ...} = Relation.lessEqual{< = op <, equals = equals}

fun output(s, out) = Pervasive.IO.output(out, s)

val maxLength = PS.maxSize  (* PS.maxLen *)

fun make(n, c) =
    let fun loop n = if n = 0 then []
		     else c :: (loop(n - 1))
    in implode(loop n)
    end
   
fun substring1(s, {start, length}) =
   PS.substring(s, start, length)

fun substring2(s, {start, finish}) =
   PS.substring(s, start, finish-start)

fun prefix(s, len) =
   substring1(s, {start = 0,
		 length = len})

fun suffix(s, len) =
   substring1(s, {start = length s - len,
		  length = len})
   
fun dropSuffix(s,n) =
   substring1(s, {start=0, length = length s - n})

fun dropLast s = dropSuffix(s, 1)

fun dropPrefix(s,n) =
   substring2(s, {start=n, finish = length s})

fun isPrefix{string, prefix} = PS.isPrefix prefix string

val fromChar = PS.str

(*fun toPrintable s =
   concat(List.map Char.toPrintable (explode s))*)

fun split(s, c) =
   let
      val max = length s
      fun loop(start, cur) =
	 if cur = max
	    then [substring2(s, {start = start, finish = max})]
	 else if Char.equals(sub(s, cur), c)
		 then substring2(s, {start = start, finish = cur})
		    :: loop(cur + 1, cur + 1)
	      else loop(start, cur + 1)
   in loop(0, 0)
   end

fun max(s1, s2) = if s1 > s2 then s1 else s2
fun min(s1, s2) = if s1 < s2 then s1 else s2

local open Int
in
   fun isSuffix{string, suffix} =
      let val n = length string
	 val n' = length suffix
	 fun loop(i, j) =
	    i = n orelse (Char.equals(sub(string, i), sub(suffix, j))
			  andalso loop(i + 1, j + 1))
      in n' <= n andalso loop(n - n', 0)
      end

   fun isSubstring{string, substring} =
      let val n = length substring
	 val maxIndex = length string - n
	 fun loop i =
	    i < maxIndex
	    andalso (let
			fun loop(i, j) =
			   j = n
			   orelse (Char.equals(sub(string, i), sub(substring, j))
				   andalso loop(i + 1, j + 1))
		     in loop(i, 0)
		     end
			orelse loop(i + 1))
      in loop 0
      end
end

val toCString = translate Char.toCString

end
