signature SHORTEST_PATH_CHECK_STRUCTS =
   sig
      structure Graph: DIRECTED_GRAPH
      structure Weight: WEIGHT
   end

signature SHORTEST_PATH_CHECK =
   sig
      include SHORTEST_PATH_CHECK_STRUCTS

      structure Answer :
	 sig
	    datatype t =
	       Shortest
	     | SourceNonZero
	     | PredecessorReachable of Graph.Edge.t
	     | Relaxable of Graph.Edge.t
	     | NoPath of Graph.Node.t
	    val output: t * (string -> unit) -> unit
	 end
	 
      val check: {graph: Graph.t,
		   source: Graph.Node.t,
		   weight: Graph.Edge.t -> Weight.t,
		   distance: Graph.Node.t -> Weight.t option}
	 -> Answer.t
   end
