structure G = AdjacencyList(val isDirected = true) ;
structure N = G.Node
structure E = G.Edge
structure GU = GraphUtil(structure Graph = G) ;
structure W = struct open Int open IU end ;
structure D = Dijkstra(structure Graph = G
		       structure Weight = W) ;
structure C = ShortestPathCheck(structure Graph = G
				structure Weight = W) ;
fun input ins = GU.input ins (N.intTo o Int.input) W.input ;

fun dijkstraI ins =
   let val (graph, source, weight) = input ins
   in {graph = graph,
       source = source,
       weight = weight,
       distance = D.shortestPath{graph = graph,
				 weight = weight,
				 source = source}}
   end

fun dijkstraO {graph, distance, source, weight} out =
   let fun distString n = (case distance n of
			      SOME d => Int.toString d
			    | NONE => "inifinity")
      val first = ref true
   in GU.foreachNode graph (fn n =>
			    (if !first then first := false else out " " ;
			     out (distString n)))
   end

fun test f = run (fn () => C.check (dijkstraI (In.openIn f)))

val f = "/afs/cs/usr/sweeks/lib/sml/graph/rand-dir" ;

test f ;

val (graph, source, weight) = run (fn () => input (In.openIn f))


   
   RunCML.shutdown() ;
   
open DirectedGraph ;

val g = new(): int Graph.t ;

val [n1,n2,n3,n4,n5,n6,n7,n8] = List.map [1, 2, 3, 4, 5, 6, 7, 8] (newNode g) ;

ListMine.foreach [(n1,n2), (n1,n4), (n1,n5),
		  (n2,n3), (n2,n4),
		  (n3,n1),
		  (n4,n3),
		  (n5,n4),
		  (n6,n7), (n6,n8),
		  (n7,n5),
		  (n8,n4), (n8,n6), (n8,n7)]
(fn (n,n') => addEdge g n n') ;

val d = dfs g ;

DfsForest.output d (fn n => Integer.output n print) print ;

(*
val t = topologicalSort g;
*)

val tr = transpose g ;

val dtr = dfs tr ;
   
DfsForest.output dtr (fn node => Integer.output (Node.value node) print) out ;

val s = stronglyConnectedComponents g ;

val ds = dfs s ;

DfsForest.output ds (fn ref nodes =>
		     (print "[" ;
		      ListUtil.output nodes ", "
		      (fn node => Integer.output (Node.value node) print)
		      print ;
		      out "]")) out ;
