signature ENV_STRUCTS =
   sig
      structure Domain: T
   end

signature ENV =
   sig
      include ENV_STRUCTS
      
      type 'a t

      val size: 'a t -> int
      val new: Domain.t list * (Domain.t -> 'a) -> 'a t
      val fromList: (Domain.t * 'a) list -> 'a t
      val toList: 'a t -> (Domain.t * 'a) list
      val empty: unit -> 'a t
      val single: Domain.t * 'a -> 'a t
      val isEmpty: 'a t -> bool

      val domain: 'a t -> Domain.t list
	 
      val singleton: Domain.t * 'a -> 'a t
      val extend: 'a t * Domain.t * 'a -> 'a t
      val + : 'a t * 'a t -> 'a t
      val plus: 'a t list -> 'a t
      val multiExtend: 'a t * Domain.t list * 'a list -> 'a t

      val peek: 'a t * Domain.t -> 'a option
      val lookup: 'a t * Domain.t -> 'a

      val restrict: 'a t * Domain.t list -> 'a t
      val remove: 'a t * Domain.t -> 'a t

      val map: 'a t * ('a -> 'b) -> 'b t
      val mapi: 'a t * (Domain.t * 'a -> 'b) -> 'b t
      val fold: 'a t * 'b * ('a * 'b -> 'b) -> 'b
      val foldi: 'a t * 'b * (Domain.t * 'a * 'b -> 'b) -> 'b
      val foreach: 'a t * ('a -> unit) -> unit
      val foreachi: 'a t * (Domain.t * 'a -> unit) -> unit
      val forall: 'a t * ('a -> bool) -> bool
      val foralli: 'a t * (Domain.t * 'a -> bool) -> bool

      val equals: ('a * 'a -> bool) -> 'a t * 'a t -> bool
      val layout: ('a -> Layout.t) -> 'a t -> Layout.t
      val maybeLayout: string * ('a -> Layout.t) -> 'a t -> Layout.t
   end
