signature MONO_ENV_STRUCTS =
   sig
      structure Domain: T
      structure Range: T
   end

signature BASIC_MONO_ENV =
   sig
      include MONO_ENV_STRUCTS
	 
      type t
      val fromList: (Domain.t * Range.t) list -> t
      val toList: t -> (Domain.t * Range.t) list
      val peek: t * Domain.t -> Range.t option
      val extend: t * Domain.t * Range.t -> t
   end

signature MONO_ENV = 
   sig
      include BASIC_MONO_ENV
      
      val size: t -> int
      val lookup: t * Domain.t -> Range.t
      val new: Domain.t list * (Domain.t -> Range.t) -> t
      val empty: t
      val single: Domain.t * Range.t -> t
      val isEmpty: t -> bool
      val domain: t -> Domain.t list
      val + : t * t -> t
      val plus: t list -> t
      val multiExtend: t * Domain.t list * Range.t list -> t
      val restrict: t * Domain.t list -> t
      val remove: t * Domain.t -> t
      val map: t * (Range.t -> Range.t) -> t
      val mapi: t * (Domain.t * Range.t -> Range.t) -> t
      val fold: t * 'a * (Range.t * 'a -> 'a) -> 'a
      val foldi: t * 'a * (Domain.t * Range.t * 'a -> 'a) -> 'a
      val foreach: t * (Range.t -> unit) -> unit
      val foreachi: t * (Domain.t * Range.t -> unit) -> unit
      val equals: t * t -> bool
      val layout: t -> Layout.t
   end
