signature FOREST_HEAP =
   sig
      structure K: BOUNDED_ORDER
      structure E :
	 sig
	    type 'a t
	    val key: 'a t -> K.t
	    val value: 'a t -> 'a
	 end
      
      type 'a t

      val empty: unit -> 'a t
      val isEmpty: 'a t -> bool
	 
      val newLazy: (K.t * 'a) list -> 'a t
      val newEager:  (K.t * 'a) list -> 'a t
	 
      val insertLazy: 'a t * K.t * 'a -> 'a E.t
      val insertEager: 'a t * K.t * 'a -> 'a E.t
	 
      val min: 'a t -> 'a E.t
      val deleteMin: 'a t -> 'a
      val decreaseKeySift: 'a t * 'a E.t * K.t -> unit
      val decreaseKeyCut: 'a t * 'a E.t * K.t -> unit
      val deleteSift: 'a t * 'a E.t -> unit
      val deleteCut: 'a t * 'a E.t -> unit
      val unionLazy: 'a t * 'a t -> unit
      val unionEager: 'a t * 'a t -> unit
      (* unions second heap into first, destroys second heap *)

      val output: 'a t
	  * ('a * Out.t -> unit)
	  * Out.t
	  -> unit
   end
