signature HEAP =
   sig
      structure Key: BOUNDED_ORDER
      structure Element:
	 sig
	    type 'a t
	    val key: 'a t -> Key.t
	    val value: 'a t -> 'a
	 end
      
      type 'a t

      val empty: unit -> 'a t
	 
      val new: (Key.t * 'a) list -> 'a t
      val insert: 'a t * Key.t * 'a -> 'a Element.t
	 
      val isEmpty: 'a t -> bool
	 
      val min: 'a t -> 'a Element.t
      val deleteMin: 'a t -> 'a
      val decreaseKey: 'a t * 'a Element.t * Key.t -> unit
      val delete: 'a t * 'a Element.t -> unit
	 
      val union: 'a t * 'a t -> unit
      (* unions second heap into first, destroys second heap *)

(*       val output: 'a t
 * 	  * ('a * Out.t -> unit)
 * 	  * Out.t
 * 	  -> unit
 *)
   end
