signature FOREST_HEAP =
   sig
      structure Key: BOUNDED_ORDER
	 
      structure Elt :
	 sig
	    type 'a t
	    val key: 'a t -> Key.t
	    val value: 'a t -> 'a
	 end
      
      type 'a t

      val empty: unit -> '1a t
      val isEmpty: 'a t -> bool
	 
      val newLazy: (Key.t * '1a) list -> '1a t
      val newEager:  (Key.t * '1a) list -> '1a t
	 
      val insertLazy: '1a t * Key.t * '1a -> '1a Elt.t
      val insertEager: '1a t * Key.t * '1a -> '1a Elt.t
	 
      val min: '1a t -> '1a Elt.t
      val deleteMin: '1a t -> '1a
      val decreaseKeySift: '1a t * '1a Elt.t * Key.t -> unit
      val decreaseKeyCut: '1a t * '1a Elt.t * Key.t -> unit
      val deleteSift: '1a t * '1a Elt.t -> unit
      val deleteCut: '1a t * '1a Elt.t -> unit
      val unionLazy: '1a t * '1a t -> unit
      val unionEager: '1a t * '1a t -> unit
      (* unions second heap into first, destroys second heap *)

      val output: 'a t
	  * ('a * (string -> unit) -> unit)
	  * (string -> unit)
	  -> unit
   end
