signature HEAP =
   sig
      structure Key: BOUNDED_ORDER

      structure Elt :
	 sig
	    type 'a t
	    val key: 'a t -> Key.t
	    val value: 'a t -> 'a
	 end
      
      type 'a t

      val empty: unit -> '1a t
	 
      val new: (Key.t * '1a) list -> '1a t
      val insert: '1a t * Key.t * '1a -> '1a Elt.t
	 
      val isEmpty: 'a t -> bool
	 
      val min: '1a t -> '1a Elt.t
      val deleteMin: '1a t -> '1a
      val decreaseKey: '1a t * '1a Elt.t * Key.t -> unit
      val delete: '1a t * '1a Elt.t -> unit
	 
      val union: '1a t * '1a t -> unit
      (* unions second heap into first, destroys second heap *)

      val output: 'a t
	  * ('a * outstream -> unit)
	  * outstream
	  -> unit
   end
