(*-------------------------------------------------------------------*)
(*                            RingEltList                            *)
(*-------------------------------------------------------------------*)

functor RingEltList(structure L: LIST
		    structure R: ORDERED_RING): RING_ELT_LIST =
struct

structure R = R
open L
   
val op + = fn l => fold(l, R.zero, R.+)

val op * = fn l => fold(l, R.one, R.* )

fun mapFromTo(n, m, f) =
   iterate(n, fn n => if R.>(n, m) then Empty
		      else First(f n, R.add1 n))
   
fun fromTo(n, m) = mapFromTo(n, m, fn x => x)

(*val equals = fn (l, l') => L.equals(l, l', R.equals)
	 
fun output(l, out) = L.output(l, ", ", R.output, out)
  *) 
end

structure IntList = RingEltList(structure L = List
				structure R = Int)
