(*-------------------------------------------------------------------*)
(*                              Counter                              *)
(*-------------------------------------------------------------------*)

functor Counter(): COUNTER =
struct

structure I = Int
structure R = RingEltRef(I)
   
datatype t = T of R.t

fun new n = T(ref n)

fun reset(T r, n) = r := n

fun tick(T r) = R.inc r

fun value(T r) = !r

fun next c = value c before tick c

val equals = fn (T r, T r') => r = r'
   
end

structure Counter = Counter(Int)
