signature DIR =
   sig
      type t
      type file
	 
      val root: t

      val temp: unit -> t
      val inTemp: (unit -> 'a) -> 'a
	 
      val current: unit -> t
      val change: t -> unit
      val parent: t -> t
      val inDir: t * (unit -> 'a) -> 'a
      val remove: t -> unit
      val removeR: t -> unit (* remove recursively, i.e. all contents *)
      val make: t -> unit
	 
      val fromString: string -> t
      val relative: t * string -> t
      val toString: t -> string
	 
      val list: t -> t list * file list
      val dirs: t -> t list
      val files: t -> file list
	 
      (* descends subdirectories *)
      val foreachFile: t * (file -> unit) -> unit

      val layout: t -> Layout.t
   end
