signature FILE =
   sig
      type t
      type dir

      val appendSuffix: t * string -> t
      val canRead: t -> bool
      val canWrite: t -> bool
      val concat: t list * t -> unit
      val contents: t -> string
      val copy: t * t -> unit
      val create: t -> unit (* make an empty file *)
      val dir: t -> dir
      val ensureRead: t -> unit
      val ensureWrite: t -> unit
      val fromString: string -> t
      val ignore : Out.t * (unit -> 'a) -> 'a
      val isNewer: t * t -> bool
      val layout: t -> Layout.t
      val lines: t -> string list
      val modTime: t -> Time.t
      val move: {from: t, to: t} -> unit
      val name: t -> string
      val output: t * Out.t -> unit
      val outputContents: t * Out.t -> unit
      val relative: dir * string -> t
      val remove: t -> unit
      val sameContents: t * t -> bool
      val size: t -> int
      val stringify : (t -> 'a) -> (string -> 'a)
      val temp: unit -> t
      val toString: t -> string
      val withAppend: t * (Out.t -> 'a) -> 'a
      val withIn: t * (In.t -> 'a) -> 'a
      val withOut: t * (Out.t -> 'a) -> 'a
      val withOutIn: (Out.t -> 'a) * (In.t -> 'b) -> 'a * 'b
      val withString : string * (t -> 'a) -> 'a
      val withStringIn : string * (In.t -> 'a) -> 'a
      val withTemp: (t -> 'a) -> 'a
   end
