(*-------------------------------------------------------------------*)
(*                              Justify                              *)
(*-------------------------------------------------------------------*)

functor Justify (): JUSTIFY =
struct

structure C = Char
structure S = String

datatype justification =
    Left
  | Center
  | Right

fun spaces n = S.make(n, C.space)
    
fun justify (s, width, just) =
    let val numchars = S.size s
	val numspaces = width - numchars
    in S.concat
	(case just of
	     Left => [s, spaces numspaces]
	   | Center => let val numLeft = numspaces div 2
			   val numRight = numspaces - numLeft
		       in [spaces numLeft, s, spaces numRight]
		       end
	   | Right => [spaces numspaces, s])
    end

end

structure Justify = Justify()

