signature BASIC_INTEGER =
   sig
      include BASIC_ORDERED_RING

      val div: t * t -> t
      val mod: t * t -> t
      val quot: t * t -> t
      val rem: t * t -> t

      (* randomRange(i, j)() is uniform in [i, j]
       * It is curried because it does some computation with i and j.
       *)
      val randomRange: t * t -> unit -> t
	 
      val toReal: t -> real
      val toInt: t -> int
      val fromInt: int -> t

      exception Input
      val input: In.t -> t

      val toString: t -> string
      val fromString: string -> t option
   end
