signature BASIC_REAL =
   sig
      include BASIC_ORDERED_FIELD

      structure Format :
	 sig
	    type t
	    val sci: int option -> t
	    val fix: int option -> t
	    val gen: int option -> t
	 end
      structure I: INTEGER

      val random: t * t -> t
      val floor: t -> I.t
      val ceiling: t -> I.t
      val sin: real -> real
      val cos: real -> real
      val atan: real -> real
      val atan2: real * real -> real
      val ln: t -> t
      val exp: t -> t
      val sqrt: t -> t
      val fromInt: I.t -> t
      val fromReal: real -> t
      val toReal: t -> real
      val toString: t -> string
      val fromString: string -> t option
      exception Input
      val input: In.t -> t
      val format: t * Format.t -> string
   end

