signature INTEGER =
   sig
      include ORDERED_RING

      (* include BASIC_INTEGER *)
      val div: t * t -> t
      val mod: t * t -> t
      val quot: t * t -> t
      val rem: t * t -> t
      val randomRange: t * t -> unit -> t
      val toReal: t -> real
      val toInt: t -> int
      val fromInt: int -> t
      exception Input
      val input: In.t -> t
      val toString: t -> string
      val fromString: string -> t option
      (* *)

      val toCommaString: t -> string

      val output: t * Out.t -> unit

      val inputBetween :
	 {ins: In.t,
	  error: unit -> unit,
	  min: t,
	  max: t} -> t
	 
      val isEven: t -> bool
      val isOdd: t -> bool

      val choose: t * t -> t

      val ^ : t * t -> t

      val gcd: t * t -> t
      val lcm: t * t -> t

      (* Iteration *)
      val fromTo: {start:t, stop:t, step:t} * 'a * (t * 'a -> 'a) -> 'a
	    
      val fold: t * t * 'a * (t * 'a -> 'a) -> 'a

      val foldDown: t * t * 'a * (t * 'a -> 'a) -> 'a

      val forall: t * t * (t -> bool) -> bool
	 
      val forStep:
	 {start:t, stop:t, step:t} * (t -> unit) -> unit

      val foreach: t * t * (t -> unit) -> unit

      val forDown: t * t * (t -> unit) -> unit
   end



