(*-------------------------------------------------------------------*)
(*                            OrderedRing                            *)
(*-------------------------------------------------------------------*)
  
functor OrderedRing(R: BASIC_ORDERED_RING): ORDERED_RING =
struct

structure U = Ring(R)
open R U

fun isPositive n = n > zero

fun isNegative n = n < zero

fun abs n = if isPositive n then n else ~ n

fun foldl(from, to, b, f) =
   let fun fold(n, a) = if n > to then a
		       else fold(add1 n, f(a,n))
   in fold(from, b)
   end

local 
   fun abs (combine, base) {from, to, term} =
      foldl(from, to, base, fn (a, i) => combine(a, term i))
in
   val sum = abs((op +), zero)
   val prod = abs((op * ), one)
end

fun prodFromTo(f, t) = prod{from = f, to = t, term = fn n => n}

fun factorial n = prodFromTo(one,n)

fun max(m,n) = if m > n then m else n

fun min(m,n) = if m < n then m else n
   
end
