signature ORDERED_RING =
   sig
      include RING

      (* include BASIC_ORDERED_RING *)
      val compare: t * t -> Relation.t
      val < : t * t -> bool
      val <= : t * t -> bool
      val > : t * t -> bool
      val >= : t * t -> bool
      (* *)

      val isPositive: t -> bool
      val isNegative: t -> bool
      val abs: t -> t

      val foldl: t * t * 'a * ('a * t -> 'a) -> 'a
	 
      val sum: {from: t,
		 to: t,
		 term: t -> t} -> t
	 
      val prod: {from: t,
		  to: t,
		  term: t -> t} -> t
      val prodFromTo: t * t -> t

      val factorial: t -> t
      
      val max: t * t -> t
      val min: t * t -> t
   end

