(*-------------------------------------------------------------------*)
(*                               Real                                *)
(*-------------------------------------------------------------------*)

functor Real(R: BASIC_REAL): REAL =
struct

structure R' = OrderedField(R)
open R R'

fun choose(n, k) =
   let val k = max(k,n-k)
   in prodFromTo(add1 k,n) / factorial(n-k)
   end

fun abs x = if x >= zero then x else ~ x
   
fun log(base, arg) = (ln arg) / (ln base)
   
val ln2 = ln two
   
fun log2 x = ln x / ln2
   
val (op ^) = fn (m,n) => exp(n * ln m)

fun min(x, y) = if x > y then y else x

fun max(x, y) = if x > y then x else y
  
end
