(*-------------------------------------------------------------------*)
(*                            RingEltRef                             *)
(*-------------------------------------------------------------------*)

functor RingEltRef(R: RING): RING_ELT_REF =
struct

structure R = R
open R
   
type t = R.t Ref.t

val (op +) = fn (r, x) => r := !r + x
   
fun inc r = r + one

val (op -) = fn (r, x) => r := !r - x

fun dec r = r - one
   
val (op * ) = fn (r, x) => r := !r * x

fun counter n = let val r = ref n
		in {next = fn () => let val n = !r
				    in inc r ; n
				    end,
                    cur = fn () => !r}
		end

end
