functor PromiseCheckLoop(): PROMISE =
struct

(*val {error, ...} = Error.errors("delay", "promise")*)

structure S = System.Unsafe.Susp
   
datatype state = Delayed | Evaluating | Evaluated
    
datatype 'a t = T of state ref * 'a S.susp

fun delay th = T(ref Delayed, S.delay th)

exception Force
fun force(T(r, s)) =
   case !r of
      Delayed => (r := Evaluating ;
		  let val v = S.force s
		  in (r := Evaluated ;
		      v)
		  end)
    | Evaluated => S.force s
    | Evaluating => raise Force

end

structure PromiseCheckLoop = PromiseCheckLoop()
