(*-------------------------------------------------------------------*)
(*                         ConvertToSequence                         *)
(*-------------------------------------------------------------------*)

functor ConvertToSequence(structure S: SEQUENCE
			  type 'a t
			  val convert: 'a t -> 'a S.t): SEQUENCE =
struct


type 'a t = 'a t

fun size s = S.size(convert s)

fun foldi(s, b, f) = S.foldi(convert s, b, f)
   
fun fold(s, b, f) = S.fold(convert s, b, f)

fun fold2(s, s', b, f) = S.fold2(convert s, convert s', b, f)

fun fold3(s1, s2, s3, b, f) = S.fold3(convert s1, convert s2, convert s3, b, f)

fun foreach(a, f) = S.foreach(convert a, f)

fun foreach2(s, s', f) = S.foreach2(convert s, convert s', f)

fun foreach3(s, s', s'', f) = S.foreach3(convert s, convert s', convert s'', f)
   
fun forall(s, f) = S.forall(convert s, f)

fun forall2(s, s', f) = S.forall2(convert s, convert s', f)

fun exists(s, f) = S.exists(convert s, f)

fun contains(s, x, eq) = S.contains(convert s, x, eq)
   
val equals = fn (s, s', eq) => S.equals(convert s, convert s', eq)

fun layout p s = S.layout p (convert s)
fun layoutSep p s = S.layoutSep p (convert s)
(*fun output(sep, outElt) (a, out) = S.output(sep, outElt) (convert a, out)*)

fun isEmpty s = S.isEmpty(convert s)

val length = size
   
fun foldr(s, b, f) = S.foldr(convert s, b, f)
   
fun foldr2(s, s', b, f) = S.foldr2(convert s, convert s', b, f)
   
fun foralli(a, f) = S.foralli(convert a, f)
fun foreachi(a, f) = S.foreachi(convert a, f)

fun nth(s,n) = S.nth(convert s,n)

fun lookup(s, p) = S.lookup(convert s, p)
fun peek(s, p) = S.peek(convert s, p)

fun outputN(n, sep, outElt) (s, out) =
   S.outputN(n, sep, outElt) (convert s, out)

fun toList s = S.toList(convert s)
   
end
