signature DISJOINT_SET =
   sig
      type 'a t
	 
      val singleton: 'a -> 'a t

      (* Each set is associated with a single value.
       * When unions occur, one of the values is chosen.
       *)
      val value: 'a t -> 'a
      val setValue: 'a t * 'a -> unit
	 
      val equals: 'a t * 'a t -> bool

      val representative: 'a t -> 'a t
      val isRepresentative: 'a t -> bool

      val union: 'a t * 'a t -> unit

      val canUnion: 'a t * 'a t * ('a * 'a -> 'a option) -> bool
   end
