signature HASH_SET_STRUCTS = 
   sig
      structure Element :
	 sig
	    include T
	    val hash: t -> word
	 end

      (* how many binary operations to cache *)
      val cacheSize: int

      (* 2^bits buckets in the hash table *)
      val bits: int
   end

signature HASH_SET =
   sig
      include HASH_SET_STRUCTS
	 
      type t
	       
      val empty: t
      val singleton: Element.t -> t
      val isEmpty: t -> bool
      val foreach: t * (Element.t -> unit) -> unit
      val - : t * t -> t
      val + : t * t -> t
      val intersect: t * t -> t
      val fromList: Element.t list -> t
      val toList: t -> Element.t list
	 
      val plist: t -> PropertyList.t

      val equals: t * t -> bool
      val layout: t -> Layout.t

      val reset: unit -> unit

      val stats: unit -> {hits: int, misses: int}
   end
