signature SET_STRUCTS =
   sig
      structure Element: T
   end

signature SET =
   sig
      include MONO_CONTAINER

      (* include ORDER *)
      val < : t * t -> bool
      val <= : t * t -> bool
      val > : t * t -> bool
      val >= : t * t -> bool
      (* *)

      val + : t * t -> t
      val - : t * t -> t
      val intersect: t * t -> t

      val unions: t list -> t

      val subset: t * (Element.t -> bool) -> t
      val subsetSize: t * (Element.t -> bool) -> int
      val map: t * (Element.t -> Element.t) -> t
      val replace: t * (Element.t -> Element.t option) -> t

      val fold: t * 'a * (Element.t * 'a -> 'a) -> 'a

      val empty: t
      val singleton: Element.t -> t
      val add: t * Element.t -> t
      val remove: t * Element.t -> t
	 
      val contains: t * Element.t -> bool
      val isEmpty: t -> bool

      val power: t -> t list
      val subsets: t * Int.t -> t list

      val areDisjoint: t * t -> bool

      (* list must contain no duplicates *)
      val fromList: Element.t list -> t
      val toList: t -> Element.t list
   end
