signature TIME = 
   sig
      type int = Int32.int

      include ORDER

      val zero: t
      val now: unit -> t
      type times =
	  {
            elapsed: t,  (* elapsed system time *)
            utime  : t,  (* user time of process *)
            stime  : t,  (* system time of process *)
            cutime : t,  (* user time of terminated child processes *)
            cstime : t   (* system time of terminated child processes *)
          }
      val times: unit -> times
      val fromReal: real -> t
      val toReal: t -> real
      val toSeconds: t -> int
      val fromSeconds: int -> t
      val toMilliseconds: t -> int
      val fromMilliseconds: int -> t
      val toMicroseconds: t -> int
      val fromMicroseconds: int -> t
      val + : t * t -> t
      val - : t * t -> t

      val toString: t -> string
(*      val fromString: string -> t option *)

      val output: t * Out.t -> unit
   end
