(* Copyright (C) 1997-1999 NEC Research Institute.
 * Please see the file LICENSE for license information.
 *)
signature PRIM_ENV_STRUCTS = 
   sig
      include ELABORATE

      val preprocess: In.t * Basis.t * Accum.t -> Basis.t * Accum.t
   end

signature PRIM_ENV = 
   sig
      include PRIM_ENV_STRUCTS

      (* all primEnv's are delayed *)
      val defunctorize: unit -> Accum.t * CoreML.Constructors.t
(*      val monomorphise: unit -> Accum.t * CoreML.Constructors.t *)
      val compile: unit -> Accum.t * Decs.t * CoreML.Constructors.t

      (* ML code that must be prefixed to any monomorphised program.  This
       * is necessary because the monomorphic internal language (Sxml) does not
       * deal with record types, but some of the basis library functions do.
       * This code mediates between the record types used in the basis library
       * and the tuple types used in the monomorphised output
       *)
(*      val getPatchRecordTypes: unit -> Layout.t *)

      (* force all primEnv's to be computed now *)
      val forceAll: Dir.t -> unit
   end
