(* Copyright (C) 1997-1999 NEC Research Institute.
 * Please see the file LICENSE for license information.
 *)
signature MATCH_COMPILE_STRUCTS =
   sig
      include ATOMS
      structure Type :
	 sig
	    type t
	    val detuple: t -> t list
	    val layout: t -> Layout.t
	 end
      structure Exp :
	 sig
	    type t
	    val const: Const.t -> t
	    val var: Var.t * Type.t -> t
	    val detuple: {tuple: t,
			  body: (Var.t * Type.t) list -> t} -> t
	    val casee: {test: t,
			default: t option,
			cases: {
				con: Con.t,
				targs: Type.t list,
				arg: (Var.t * Type.t) option,
				rhs: t
				} list,
			ty: Type.t (* type of entire case expression *)
			} -> t
	    val lett: {var: Var.t, exp: t, body: t} -> t
	    val iff: {test: t, thenn: t, elsee: t, ty: Type.t} -> t
	    val equal: t * t -> t
	    val deref: t -> t
	    val layout: t -> Layout.t
	 end
      structure NestedPat: NESTED_PAT
      sharing Atoms = NestedPat.Atoms
      sharing Type = NestedPat.Type
   end

signature MATCH_COMPILE =
   sig
      include MATCH_COMPILE_STRUCTS

      val matchCompile :
	 {conTycon: Con.t -> Tycon.t,
	  tyconCons: Tycon.t -> Con.t list,
	  test: Var.t,
	  testType: Type.t,
	  caseType: Type.t, (* type of entire expression *)
	  cases: (NestedPat.t * ((Var.t -> Var.t) -> Exp.t)) list}
	 -> Exp.t
   end
